---
title: '<xsl:for-each>'
slug: Web/XSLT/Element/for-each
tags:
  - Element
  - Reference
  - XSLT
  - for
  - for-each
---
<p>{{ XsltRef() }}</p>

<p>The <code>&lt;xsl:for-each&gt;</code> element selects a set of nodes and processes each of them in the same way. It is often used to iterate through a set of nodes or to change the current node. If one or more <code>&lt;xsl:sort&gt;</code> elements appear as the children of this element, sorting occurs before processing. Otherwise, nodes are processed in document order.</p>

<h3 id="Syntax">Syntax</h3>

<pre>&lt;xsl:for-each select=EXPRESSION&gt;
	&lt;xsl:sort&gt; [optional]
	TEMPLATE
&lt;/xsl:for-each&gt;</pre>

<h3 id="Required_Attributes">Required Attributes</h3>

<dl>
 <dt><code>select</code></dt>
 <dd>Uses an XPath expression to select nodes to be processed.</dd>
</dl>

<h3 id="Optional_Attributes">Optional Attributes</h3>

<p>None.</p>

<h3 id="Type">Type</h3>

<p>Instruction, appears within a template.</p>

<h3 id="Defined">Defined</h3>

<p>XSLT, section 8.</p>

<h3 id="Gecko_support">Gecko support</h3>

<p>Supported.</p>
